// For legal information, please see the notice at the bottom of this file,
// which has been moved due to efficiency considerations.

// Browser Abstraction Layer ;-)
// Browser detection (NN 4.x, IE 4.x & 5.x, Opera 4.x+, DOM[5+] browsers)
var isOpera = (navigator.userAgent.indexOf("Opera") != -1);     // General Opera
var isNN = (navigator.appName == "Netscape" && !isOpera);    // General Netscape
var isGen3 = (parseInt(navigator.appVersion) >= 3 && parseInt(
	navigator.appVersion) < 4);                          // Generation 3 Browser
var isNN4 = (isNN && parseInt(navigator.appVersion) >= 4 && parseInt(
	navigator.appVersion) < 5);                        // Netscape Navigator 4.x
var isNN6 = (isNN && parseInt(navigator.appVersion) >= 5 && parseInt(
	navigator.appVersion) < 6);                                    // Netscape 6
var isIE = (navigator.appName == "Microsoft Internet Explorer"); // General MSIE
var isIE3 = (isIE && navigator.appVersion < 4);         // Internet Explorer 3.x
var isIE4 = (isIE && parseInt(navigator.appVersion) >= 4);          // MSIE 4.0+
var isIE5 = (isIE && parseInt(navigator.appVersion) >= 5);          // MSIE 5.0+
var isIE6 = (isIE && parseInt(navigator.appVersion) >= 6);          // MSIE 6.0+
var isOpera4 = (isOpera && navigator.userAgent.indexOf("4.0") != -1)  // Opera 4
var isOpera5 = (isOpera && navigator.userAgent.indexOf("5.") != -1)   // Opera 5
var isDocom = (document.getElementById != null);          // Generic DOM Browser
var isWin2k = (navigator.userAgent.indexOf(
	"Windows NT 5.0") != -1);                       // Running on Windows 2000 ?
var isIEMac = (isIE && !isDocom && navigator.userAgent.indexOf(
	"Macintosh") != -1);                          // Internet Explorer for Mac ?
var isDHTMLBrowser = (isIE4 || isNN4 || isOpera4 || isDocom); // DHTML-support ?
var isWin31 = (navigator.appVersion.indexOf(
	"Win16") != -1);                                // Running on Windows 3.1x ?

var VIS_SHOW, VIS_HIDE;                                    // Show or hide layer

if (isIE4 || isDocom) {
	VIS_SHOW = "visible";
	VIS_HIDE = "hidden";
} else {
	VIS_SHOW = "show";
	VIS_HIDE = "hide";
}

// Misc. functions
var imageCache = new Array();

// Create an array with any number of arguments:
// var myArray = new arrayDef([Item,{Item}]);
function arrayDef() {
	this.length = arrayDef.arguments.length;
	for (var i = 0; i < this.length ; i++)
		this[i] = arrayDef.arguments[i];
}

// Load any number of images into cache:
// cacheImages(["filepath"{,"filepath"}]
function cacheImages() {
	if (document.images && !isOpera) {
		for (var i = 0; i < cacheImages.arguments.length; i++) {
			imageCache[i] =     new Image();
			imageCache[i].src = cacheImages.arguments[i];
		}
	}
}

// Popup a preformatted Email window
function popupFmtEmail(to, cc, bcc, subject, body) {
	window.location = "mailto:" + to + "?cc=" + cc + "&bcc=" + bcc +
		"&subject=" + escape(subject) + "&body=" + escape(body);
}

// TIME-CRITICAL core routines
var buf = '<script language="JavaScript"><!--\n';

buf += 'function moveX(ID,x){';
if (isDocom) buf += "document.getElementById(ID).style.left=x;"; else
if (isIE4)   buf += "document.all[ID].style.pixelLeft=x;"; else
if (isNN4)   buf += "eval('document.'+ID+'.left='+x);";
buf += '}';

buf += 'function moveY(ID,y){';
if (isDocom) buf += "document.getElementById(ID).style.top=y;"; else
if (isIE4)   buf += "document.all[ID].style.pixelTop=y;"; else
if (isNN4)   buf += "eval('document.'+ID+'.top='+y);";
buf += '}';

buf += 'function move(ID,x,y){';
if (isDocom) buf += "document.getElementById(ID).style.top=y;document.getElementById(ID).style.left=x;"; else
if (isIE4)   buf += "document.all[ID].style.pixelTop=y;document.all[ID].style.pixelLeft=x;"; else
if (isNN4)   buf += "document.layers[ID].top=y;document.layers[ID].left=x;";
buf += '}';

buf += 'function clip(ID,x0,y0,x1,y1){';
if (isDocom) buf += "document.getElementById(ID).style.clip='rect('+y0+','+x1+','+y1+','+x0+')';"; else
if (isIE4)   buf += "document.all[ID].style.clip='rect('+y0+','+x1+','+y1+','+x0+')';"; else
if (isNN4)   buf += "with(eval('document.'+ID)){clip.top=y0;clip.right=x1;clip.bottom=y1;clip.left=x0;}";
buf += '}';

buf += 'function left(ID){';
if (isIE4)   buf += "return eval('document.all.'+ID+'.style.pixelLeft');"; else
if (isNN4)   buf += "return eval('document.'+ID+'.left');"; else
if (isDocom) buf += "return document.getElementById(ID).offsetLeft;";
buf += '}';

buf += 'function top(ID){';
if (isIE4)   buf += "return eval('document.all.'+ID+'.style.pixelTop');"; else
if (isNN4)   buf += "return eval('document.'+ID+'.top');"; else
if (isDocom) buf += "return document.getElementById(ID).offsetTop;";
buf += '}';

buf += 'function width(ID){';
if (isIE4)   buf += "return eval('document.all.'+ID+'.offsetWidth');"; else
if (isNN4)   buf += "return eval('document.'+ID+'.document.width');"; else
if (isDocom) buf += "return document.getElementById(ID).offsetWidth;";
buf += '}';

buf += 'function height(ID){';
if (isIE4)   buf += "return eval('document.all.'+ID+'.offsetHeight');"; else
if (isNN4)   buf += "return eval('document.'+ID+'.document.height');"; else
if (isDocom) buf += "return document.getElementById(ID).offsetHeight;";
buf += '}';

buf += 'function clientWidth(){';
if (isIE4)   buf += "return document.body.clientWidth;"; else
if (isNN4)   buf += "return window.innerWidth;"; else
if (isDocom) buf += "return document.body.offsetWidth;";
buf += '}';

buf += 'function clientHeight(){';
if (isIE4)   buf += "return document.body.clientHeight;"; else
if (isNN4)   buf += "return window.innerHeight;"; else
if (isDocom) buf += "return document.body.offsetHeight;";
buf += '}';

buf += 'function show(ID,State){';
if (isIE4)   buf += "eval('document.all.'+ID+'.style.visibility=\"'+State+'\"');"; else
if (isNN4)   buf += "eval('document.'+ID+'.visibility=\"'+State+'\"');"; else
if (isDocom) buf += "document.getElementById(ID).style.visibility=State;";
buf += '}';

buf += 'function writeToLayer(ID,text){';
if (isNN4)   buf += "eval('document.layers.'+ID+'.document.write(\\''+text+'\\');document.layers.'+ID+'.document.close()');"; else
if (isIE4)   buf += "eval('document.all.'+ID+'.innerHTML=\\''+text+'\\'');"; else
if (isDocom) buf += "document.getElementById(ID).innerHTML=text;";
buf += '}';

document.write(buf + '//--></script>');
// end TIME-CRITICAL

function centerX(ID) {moveX(ID, (clientWidth() - width(ID)) / 2);}
function centerY(ID) {moveY(ID, (clientHeight() - height(ID)) / 2);}
function center(ID) {move(ID, (clientWidth() - width(ID)) / 2, (clientHeight() - height(ID)) / 2);}

function sizeX(ID, x) {
	if (isIE4) eval('document.all.' + ID + '.style.pixelWidth=' + x); else
	if (isNN4) eval('document.' + ID + '.resizeTo(' + x + ',document.' + ID + '.document.height)'); else
	if (isDocom) document.getElementById(ID).offsetWidth = x;
}

function sizeY(ID, y) {
	if (isIE4) eval('document.all.' + ID + '.style.pixelHeight=' + y); else
	if (isNN4) eval('document.' + ID + '.resizeTo(document.' + ID + '.document.width,' + y + ')'); else
	if (isDocom) document.getElementById(ID).offsetHeight = y;
}

function size(ID, x, y) {
	if (isIE4) eval('document.all.' + ID + '.style.pixelWidth=' + x + ';document.all.' + ID + '.style.pixelHeight=' + y); else
	if (isNN4) eval('document.' + ID + '.resizeTo(' + x + ',' + y + ')'); else
	if (isDocom) {
		document.getElementById(ID).offsetWidth = x;
		document.getElementById(ID).offsetWidth = y;
	}
}

function noop() {
	if (isIE4) document.body.focus();
}

////////////////////////////////////////////////////////////////////////////////
// Original Filename: BAL.js                                                  //
// Version:           0.5 (beta)                                              //
// Copyright:         (c)2000,20001 by Christian Blichmann.                   //
//                    All rights reserved.                                    //
////////////////////////////////////////////////////////////////////////////////
// DISCLAIMER OF WARRANTY: The Script may contain pre-release code which may  //
// be modified substantially or obtain additional features before general     //
// availability. You should exercise caution in the use of the script. The    //
// Beta Script may not be at the level of performance or compatibility of     //
// generally available products, and should not be used for productive        //
// purposes. In addition, I do not provide any maintenance, upgrades or other //
// support, except through separate agreement.                                //
//                                                                            //
// THIS SCRIPT IS PROVIDED "AS IS" WITHOUT WARRANTY OR CONDITION OF ANY KIND  //
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED      //
// WARRANTY OR CONDITION OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR      //
// PURPOSE. THE ENTIRE RISK ARISING OUT OF THE USE OR PERFORMANCE OF THE      //
// PROGRAMS AND DOCUMENTATION REMAINS WITH YOU. IN NO EVENT WILL CHRISTIAN    //
// BLICHMANN BE LIABLE FOR ANY DIRECT OR INDIRECT DAMAGE INCLUDING BUT NOT    //
// LIMITED TO LOST PROFITS, LOST SAVINGS, DIRECT, INDIRECT OR OTHER ECONOMIC  //
// CONSEQUENTIAL DAMAGES, EVEN IF CHRISTIAN BLICHMANN HAS BEEN ADVISED OF     //
// THE POSSIBILITY OF SUCH DAMAGES. IN ADDITION CHRISTIAN BLICHMANN WILL NOT  //
// BE LIABLE FOR ANY DAMAGES CLAIMED BY YOU BASED ON ANY THIRD PARTY CLAIM.   //
////////////////////////////////////////////////////////////////////////////////